// LiftClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LiftClient.h"
#include "LiftClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


class CLift
{
public:
	bool busy;
	bool door;
	int pos;
};

CLift *g_lifts;
int g_num;

/////////////////////////////////////////////////////////////////////////////
// CMyDlg dialog

CMyDlg::CMyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CMyDlg::~CMyDlg()
{
	closesocket(m_socket);
	WSACleanup();
}


void CMyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyDlg, CDialog)
	//{{AFX_MSG_MAP(CMyDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDC_CONNECT, OnConnect)
	ON_COMMAND(IDC_TEST, OnStart)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyDlg message handlers

BOOL CMyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetDlgItemText(IDC_ADDRESS,"localhost");
	SetDlgItemInt(IDC_PORT, 5438);
	m_start=false;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMyDlg::OnConnect()
{
	// init 
	WORD wVersionRequested = MAKEWORD(1,1);
    WSADATA data;
	if (WSAStartup(wVersionRequested, &data) != 0)
    {
        MessageBox("Chyba se vytvareni socketu!");
        return;
    }

	// preklad jmena
	char address[100];
	int port;
	GetDlgItemText(IDC_ADDRESS, address, 100);
	port = GetDlgItemInt(IDC_PORT);
	
	hostent *H = gethostbyname(address);
	if (!H)
	{
		MessageBox("Chyba v prekladu jmena! Asi mas nekde chybu!");
		WSACleanup();
		return;
	}

	// vytvoreni socketu
	if ((m_socket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1)
    {
        MessageBox("Nemohu vytvorit socket!");
        WSACleanup();
        return;
    }

	// pripojeni
	sockaddr_in server;    
	server.sin_family = AF_INET;
    server.sin_port = htons(port);
    memcpy(&(server.sin_addr), H->h_addr, H->h_length);
	if (connect(m_socket, (sockaddr *)&server, sizeof(server)) == -1)
    {
        MessageBox("Nelze se napojit na server! Opravdu bezi?");
        WSACleanup();
        return;
    }
	AddLog("Connected!");
}

void CMyDlg::AddLog(char *fmt, ...)
{
	char text[100];
	va_list ap;

	va_start(ap, fmt);
	vsprintf(text, fmt, ap);
	va_end(ap);

	SendDlgItemMessage(IDC_LOG, LB_ADDSTRING, 0, (LPARAM)text); 
}

// posle text na server
void CMyDlg::SendText(char *fmt , ...)
{
	char text[100];
	va_list ap;
	char tmp_text[100];

	va_start(ap, fmt);
	vsprintf(text, fmt, ap);
	va_end(ap);


	sprintf(tmp_text, "%s%c%c", text, 13,10);
	if (send(m_socket, tmp_text, strlen(tmp_text), 0)== -1)
	{
		MessageBox("Chyba v odesilani!");
		KillTimer(1);
	}

	char aaa[100];
	sprintf(aaa, "client: %s", text);
	AddLog(aaa);	
}

// zjiska text ze serveru
char *CMyDlg::GetText()
{
	static char tmp_text[100];

	if (recv(m_socket, tmp_text, 100, 0)== -1)
	{
		MessageBox("Chyba v prijimani!");
		KillTimer(1);
	}
	
	char aaa[100];
	sprintf(aaa, "server: %s", tmp_text);
	AddLog(aaa);
	
	return tmp_text;
}

// parsuje jednotlive zpravy vytahu
void CMyDlg::ProcessMessage(char *text)
{
	text[strlen(text)-2]=' ';
	text[strlen(text)-1]=' ';
	AddLog(text);

	if (strstr(text, "levelbuttonup"))
	{
		int num=0; 
		int num2=0;
		sscanf(text, "levelbuttonup %d", &num);
		SendText("indiupon %d", num);
		// hledani volneho vytahu
		for (int i=0; i<g_num; i++)
			if (!g_lifts[i].busy) num2=i;
		SendText("open %d", 0);
		Sleep(2000);
		SendText("floor %d %d", num2, num);
		if (num2<g_num)
			g_lifts[num2].busy=true;
	}

	if (strstr(text, "levelbuttondn"))
	{
		int num=0;
		int num2=0;
		sscanf(text, "levelbuttondn %d", &num);
		SendText("indidnon %d", num);
		// hledani volneho vytahu
		for (int i=0; i<g_num; i++)
			if (!g_lifts[i].busy) num2=i;
		SendText("open %d", 0);
		Sleep(2000);
		SendText("floor %d %d", num2, num);
		if (num2<g_num)
			g_lifts[num2].busy=true;

	}

	// nastava po startu systemu
	if (strstr(text, "shafts"))
	{
		int num=0;
		sscanf(text, "shafts %d", &num);
		g_lifts = new CLift[num];
		g_num = num;
	}

	// zmacknute tlacitko v kabine
	if (strstr(text, "cabinbutton"))
	{
		int num=0, num2=0; 
		sscanf(text, "cabinbutton %d %d", &num, &num2);
		//SendText("indion %d %d", num, num2);
		
		if (!g_lifts[num].door) 
			SendText("floor %d %d", num, num2);
		SendText("open %d", num);		
		SendText("shaftinfo %d %d", num, num2);
		if (num<g_num)
			g_lifts[num].busy=false;
	}

	if (strstr(text, "opened"))
	{
		int num=0;
		sscanf(text, "opened %d", &num);
		g_lifts[num].door=true;
	}

	if (strstr(text, "closed"))
	{
		int num=0;
		sscanf(text, "closed %d", &num);
		g_lifts[num].door=false;
	}
	
}

// start tlacitko
void CMyDlg::OnStart()
{
	SendText("shafts");
	ProcessMessage(GetText());
	AddLog("Pocet vytahu: %d", g_num);

	SetTimer(1, 100, NULL);
}

void CMyDlg::OnTimer(unsigned int id)
{
	ProcessMessage(GetText());	
}
